// Author: kwalsh@holycross.edu

#include <sys/alt_stdio.h>
#include <sys/alt_sys_wrappers.h>
#include <string.h>
#include <io.h>
#include <system.h>
#include "led.h"
#include "lcd.h"
#include "joystick.h"
#include "motor.h"
#include "quad.h"

int main()
{
  alt_putstr("Hello from Zebra 3.4!\n");
  led_progressbar();
  lcd_init();

  /*
  unsigned int b = 0;
  for (;;) {
    unsigned int b2 = joystick_buttons();
    if (b2 == b)
      continue;
    b = b2;
    alt_printf("buttons: %x  %x  %x  %x  %x  %x  %x  %x\n", b,
	(b&0x80)?1:0,
	(b&0x40)?1:0,
	(b&0x20)?1:0,
	(b&0x10)?1:0,
	(b&0x08)?1:0,
	(b&0x04)?1:0,
	(b&0x02)?1:0,
	(b&0x01)?1:0);
  }
  */

  // joystick_demo();
  // joystick_calibrate();
  joystick_precalibrated();
  // motor_demo();
  //motor_demo2();

  lcd_clear();
  lcd_printf("Use joysticks!\n");

#define WRISTA 6 // motor 6
#define WRISTB 5 // motor 5
#define WRISTC 4 // motor 4
#define ELBOW 3 // motor 3
#define SHOULDER 2 // motor 2
#define TORSO 1 // motor 1
#define GRIP 0 // motor 0/G

  while (1) {
    motor_go(GRIP, joystick_baxis(0, 1, 255));
    motor_go(WRISTA, (joystick_pos(0, 2)  + joystick_pos(0, 3))/ 8);
    motor_go(WRISTB, (joystick_pos(0, 2) - joystick_pos(0, 3))/ 4);
    //motor_go(WRISTC, joystick_pos(0, 0) / 4);
    motor_go(SHOULDER, joystick_pos(0, 1) / 4);//button change to joystick for shoulder
    motor_go(ELBOW, joystick_pos(0, 0) / 2);
    //motor_go(SHOULDER, joystick_baxis(4, 5, 32));
    motor_go(WRISTC, joystick_baxis(4, 5, 32));//joystick change to button for wristc
    motor_go(TORSO, joystick_baxis(2, 3, 16));

    lcd_printf("\renc1 = %d", quadrature_value(0));

    usleep(50000);
  }

  while (1);
  return 0;
}
